#!/usr/bin/perl -w

use LWP;
use Getopt::Std;

# WHAT THIS SCRIPT DOES:
# obtain list of university home URLs from webometrics.info
# INPUT:
# file with country/langfam info (countries_langfam.info)

%opts = ();

getopts('u:c:',\%opts);

if ($opts{c}) {
  open COUNTRYLIST,$opts{c} or die "could not find url list file $opts{c}";
  while (<COUNTRYLIST>) {
    chomp;
    ($country,$language_family,$europe27,$english_status) = split "[ \t]",$_;
    $lang_fam{$country} = $language_family;
    $eu27{$country} = $europe27;
    $eng_status{$country} = $english_status;
  }
  close COUNTRYLIST;
}


$womstarturl = "http://www.webometrics.info/en/Europe?page=0";

for (split /\n/, do_GET($womstarturl)) {
  if (/<a title="Go to last page" href="\/en\/Europe\?page=([0-9]+)"/) {
    $lastpage = $1;
  }
}



SCRAPE: for ($counter = 0; $counter < $lastpage;) {
  
  $womurl = "http://www.webometrics.info/en/Europe?page=$counter";
  $wompage = do_GET($womurl);
  
  for (split /\n/, $wompage) {
   chomp;
   
   if (/tbody/) {
     $intable = 1;
   }
   
   elsif ($intable && /<tr class="(odd|even)"><td><center>[0-9]+<\/center><\/td><td><center>([0-9]+)<\/center><\/td><td><a href="(http:[^"]+)" target="_blank">([^\/<]+).*\/files\/logos\/(..)\.png"/) {
      $rank = $2;
      $home = $3;
      $name = $4;
      $country = $5;
      $name =~ s/[ ]$//;
      $name =~ s/\([^\)]+\) ?//gi;
      $name =~ s/&#039;/'/gi;
      $name =~ s/&amp;/and/gi;
      $name =~ s/[ ]/_/gi;
      print "$home $name $rank $country $lang_fam{$country} $eu27{$country} $eng_status{$country}\n";
    }
   
   elsif ($intable && /<li class="pager-next">/) {
     $intable = 0;
     $counter++;
     sleep(2);
     redo SCRAPE;
   }
 }
}

# Marco Baroni's sub to fetch html from urls

sub do_GET {
    # this is taken from the perl & lwp book (but I changed it a bit)

    $browser = LWP::UserAgent->new() unless $browser;
    $browser->timeout(10);
    $browser->env_proxy();
    
    my $response;

    # I've put the following in an eval block to try to survive
    # failed ntlm authentications... let's hope it doesn't
    # cause other kinds of trouble...

    eval {$response = $browser->get(@_);};

    if ($@) {
	print STDERR "something went wrong: $@\n";
	return;
    }
    
    return unless $response->is_success;

    return $response->content;
}

